---
- name: Determine systemd mount unit name
  command: "systemd-escape -p --suffix=mount {{ data_disk.path }}"
  changed_when: false
  register: mount_unit_name
  check_mode: no

- name: Get stats for device {{ data_disk.device }}
  ansible.builtin.stat:
    path: "{{ data_disk.device }}"
  register: st
- name: Fail if the device does not exist
  ansible.builtin.fail:
    msg: "{{ data_disk.device }} does not exist"
  when: st.failed

- name: Configure device in fstab
  mount:
    path: "{{ data_disk.path }}"
    src: "{{ data_disk.device }}"
    fstype: ext4
    opts: "x-systemd.makefs"
    state: present

- name: Ensure data belongs to appropriate owner
  template:
    src: prepare_data.service
    dest: /etc/systemd/system/prepare_{{ mount_unit_name.stdout }}.service
    owner: root
    group: root
    mode: 0444
  register: prepare

- name: Prepare data
  systemd:
    name: prepare_{{ mount_unit_name.stdout }}.service
    enabled: yes
    state: restarted
    daemon_reload: yes
  when: prepare.changed
